<template>
  <div>
    <serveur-info :erreur="erreur" />
    <div class="columns" v-if="!hasLaboratoire">
      <div class="column is-half is-offset-one-quarter">
        <div class="boxicon is-bordered has-text-centered" style="margin-bottom:0">
          <div class="content">
            <p>
              <b>Aucune affiliation</b>: vous n'êtes rattaché.e à aucun laboratoire.
              <br/><br/>
              Avant de commencer, veuillez renseigner les informations relatives au laboratoire pour lequel vous êtes
              habilité.e à proposer des initiatives et soumettre des données.<br/><br/>
            </p>
            <b-button class="button is-primary is-fullwidth" type="is-primary" tag="router-link" to="/administration/my-laboratory">
              <span class="icon is-small"><i class="sui sui-flask"></i></span>
              <span>Mon laboratoire</span>
            </b-button>
          </div>
        </div>
      </div>
    </div>
    <div class="columns" v-else>
      <div class="column">
        <form @submit.prevent="validateBeforeSubmit">
          <div class="columns">
            <div class="column">
              <su-service :icon="'info'">
                <template #title>
                  Description des initiatives
                </template>
                <p v-if="initiative.id">
                  <span v-if="initiative.valid" style="opacity: 0.6; color: rgb(2, 157, 57);"><span class="icon is-small"><i class="sui sui-check"></i></span> Initiatives validées et publiques.</span>
                  <span v-else style="opacity: 0.6; color: rgb(255, 56, 96);"><span class="icon is-small"><i class="sui sui-close"></i></span> Initiatives non publiques en cours de validation.</span>
                  <br />
                  <em>Initiatives proposépkes le {{ initiative.created | dateFormat}} (dernières modifications le {{ initiative.last_update | dateFormat}}).</em>
                </p>
                <br v-if="initiative.id"/>
                Donnez une brève description de votre laboratoire ainsi que du contexte dans lequel les initiatives y sont menées.
                <br />
                <br />
                <b-field>
                  <b-checkbox
                    @input="inputChanged"
                    v-model="initiative.initiative_institutionnelle"
                  >
                    Les initiatives sont portées par la direction du laboratoire.
                  </b-checkbox>
                </b-field>
                <b-field
                  label="Description du laboratoire"
                  :type="{'is-danger': errors.has('description')}"
                  :message="errors.first('description')">
                  <b-input
                    name="description"
                    @input="inputChanged"
                    placeholder="Description du laboratoire"
                    v-model="initiative.description"
                    v-validate="'required|min:25'"
                    type="textarea"
                    maxlength="1000"
                  ></b-input>
                </b-field>
                <b-field label="Empreinte carbone" v-if="initiative.BGESext !== 2 && initiative.BGESext !== '2'">
                  <b-select
                    v-model="initiative.BGESext"
                    expanded
                    @input="inputChanged"
                    placeholder="Empreinte carbone"
                    icon="thermometer"
                  >
                    <option value="0">Non réalisé</option>
                    <option value="1">En cours</option>
                    <option value="2">Réalisé</option>
                  </b-select>
                </b-field>
                <b-field label="Empreinte carbone réalisé en" v-else>
                  <b-taginput
                    v-model="initiative.BGES_annee"
                    field="valeur"
                    icon="thermometer"
                    :data="BGESAnneeValues"
                    :allow-new="false"
                    rounded
                    @input="inputChanged"
                    @add="changeBGESAnnee()"
                    placeholder="BGES réalisé en"
                    :open-on-focus="true"
                    autocomplete
                  >
                    <template slot-scope="props">
                      {{props.option.valeur}}
                    </template>
                  </b-taginput>
                </b-field>
              </su-service>
            </div>
            <div class="column">
              <su-service :icon="'lightbulb-o'">
                <template #title>
                  Initiatives mises en place
                </template>
                Sélectionnez l'ensemble des initiatives écologiquement et/ou socialement responsables mises en place
                dans votre laboratoire afin d'avoir accès à leurs formulaires de saisie.
                <br />
                <br />
                <b-taginput
                  @input="inputChanged"
                  @remove="removeInitiative"
                  v-model="initiatives_selected"
                  field="valeur"
                  icon="caret-right"
                  :data="initiatives_categories"
                  :allow-new="false"
                  rounded
                  placeholder="Ajouter une initiative"
                  :open-on-focus="true"
                  autocomplete
                >
                  <template slot-scope="props">
                    {{props.option.valeur}}
                  </template>
                  <template slot="empty">
                    Proposer au mimimum une initiative
                  </template>
                </b-taginput>
              </su-service>
            </div>
          </div>
          <br />
          <su-service :icon="'pencil'" v-if="isInitiativeSelected('Engagements')">
            <template #title>
              Engagements (charte, manifeste, ...)
            </template>
            <b-field
              :type="{'is-danger': errors.has('engagements')}"
              :message="errors.first('engagements')">
              <b-input
                name="engagements"
                @input="inputChanged"
                placeholder="Engagements (charte, manifeste, ...)"
                v-model="initiative.engagements"
                v-validate="'required|min:25'"
                type="textarea"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Engagements')"/>
          <su-service :icon="'lightbulb-o'" v-if="isInitiativeSelected('Groupe de réflexion')">
            <template #title>
              Groupe de réflexion
            </template>
            <b-field
              :type="{'is-danger': errors.has('groupe_description')}"
              :message="errors.first('groupe_description')">
              <b-input
                name="groupe_description"
                @input="inputChanged"
                placeholder="Description du groupe de réflexion"
                v-model="initiative.groupe_description"
                v-validate="'required|min:25'"
                type="textarea"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Groupe de réflexion')"/>
          <su-service :icon="'train'" v-if="isInitiativeSelected('Déplacements professionnels')">
            <template #title>
              Déplacements professionnels
            </template>
            <b-field
              :type="{'is-danger': errors.has('deplacementspro_description')}"
              :message="errors.first('deplacementspro_description')">
              <b-input
                name="deplacementspro_description"
                placeholder="Description des initiatives pour les déplacements professionnels"
                v-model="initiative.deplacementspro_description"
                v-validate="'required|min:25'"
                type="textarea"
                @input="inputChanged"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Déplacements professionnels')"/>
          <su-service :icon="'bicycle'" v-if="isInitiativeSelected('Déplacements domicile-travail')">
            <template #title>
              Déplacements domicile-travail
            </template>
            <b-field
              :type="{'is-danger': errors.has('deplacementsdt_description')}"
              :message="errors.first('deplacementsdt_description')">
              <b-input
                name="deplacementsdt_description"
                placeholder="Description des initiatives pour les déplacements domicile–travail"
                v-model="initiative.deplacementsdt_description"
                v-validate="'required|min:25'"
                type="textarea"
                @input="inputChanged"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Déplacements domicile-travail')"/>
          <su-service :icon="'flask'" v-if="isInitiativeSelected('Activités de recherche')">
            <template #title>
              Activités de recherche
            </template>
            <b-field
              :type="{'is-danger': errors.has('actrecherche_description')}"
              :message="errors.first('actrecherche_description')">
              <b-input
                name="actrecherche_description"
                placeholder="Description des initiatives pour les activités de recherches"
                v-model="initiative.actrecherche_description"
                v-validate="'required|min:25'"
                type="textarea"
                @input="inputChanged"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Activités de recherche')"/>
          <su-service :icon="'building'" v-if="isInitiativeSelected('Bâtiments')">
            <template #title>
              Bâtiments
            </template>
            <b-field
              :type="{'is-danger': errors.has('batiments_description')}"
              :message="errors.first('batiments_description')">
              <b-input
                name="batiments_description"
                placeholder="Description des initiatives pour les Bâtiments"
                v-model="initiative.batiments_description"
                v-validate="'required|min:25'"
                type="textarea"
                @input="inputChanged"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Bâtiments')"/>
          <su-service :icon="'laptop'" v-if="isInitiativeSelected('Numérique')">
            <template #title>
              Numérique
            </template>
            <b-field
              :type="{'is-danger': errors.has('numerique_description')}"
              :message="errors.first('numerique_description')">
              <b-input
                name="numerique_description"
                placeholder="Description des initiatives pour le numérique"
                v-model="initiative.numerique_description"
                v-validate="'required|min:25'"
                type="textarea"
                @input="inputChanged"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Numérique')"/>
          <su-service :icon="'leaf'" v-if="isInitiativeSelected('Actions éco-responsables')">
            <template #title>
              Actions éco-responsables
            </template>
            <b-field
              :type="{'is-danger': errors.has('ecoresponsable')}"
              :message="errors.first('ecoresponsable')">
              <b-input
                name="ecoresponsable"
                placeholder="Autres actions éco-responsables (eau, déchets, alimentation)"
                v-model="initiative.ecoresponsable"
                v-validate="'required|min:25'"
                type="textarea"
                @input="inputChanged"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Actions éco-responsables')"/>
          <su-service :icon="'joomla'" v-if="isInitiativeSelected('Initiatives à portée sociale')">
            <template #title>
              Initiatives à portée sociale
            </template>
            <b-field
              :type="{'is-danger': errors.has('sociale')}"
              :message="errors.first('sociale')">
              <b-input
                name="sociale"
                placeholder="Initiatives à portée sociale"
                v-model="initiative.sociale"
                v-validate="'required|min:25'"
                type="textarea"
                @input="inputChanged"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Initiatives à portée sociale')"/>
          <su-service :icon="'bar-chart-o'" v-if="isInitiativeSelected('Enquêtes')">
            <template #title>
              Enquêtes
            </template>
            <b-field
              :type="{'is-danger': errors.has('enquetes')}"
              :message="errors.first('enquetes')">
              <b-input
                name="enquetes"
                placeholder="Enquêtes"
                v-model="initiative.enquetes"
                v-validate="'required|min:25'"
                type="textarea"
                @input="inputChanged"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Enquêtes')"/>
          <su-service :icon="'weixin'" v-if="isInitiativeSelected('Communication')">
            <template #title>
              Communication
            </template>
            <b-field
              :type="{'is-danger': errors.has('communication')}"
              :message="errors.first('communication')">
              <b-input
                name="communication"
                placeholder="Communication"
                v-model="initiative.communication"
                v-validate="'required|min:25'"
                @input="inputChanged"
                type="textarea"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Communication')"/>
          <su-service :icon="'sticky-note'" v-if="isInitiativeSelected('Autres')">
            <template #title>
              Autres
            </template>
            <b-field
              :type="{'is-danger': errors.has('autres_initiatives')}"
              :message="errors.first('autres_initiatives')">
              <b-input
                name="autres_initiatives"
                placeholder="Autres"
                v-model="initiative.autres_initiatives"
                v-validate="'required|min:25'"
                type="textarea"
                @input="inputChanged"
                maxlength="1000"
              ></b-input>
            </b-field>
          </su-service>
          <br v-if="isInitiativeSelected('Autres')"/>
          <nav class="level">
            <div class="level-left"></div>
            <div class="buttons level-right">
              <b-button
                class="button"
                @click="resetForm()"
                :disabled="!hasChanged"
                icon-left="close"
              >
                Annuler
              </b-button>
              <button
                type="submit"
                :disabled="isDisabled"
                @click="scrollOnTop()"
                class="button is-primary"
              >
                <span class="icon is-small"><i class="sui sui-save"></i></span>
                <span> Sauvegarder </span>
              </button>
            </div>
          </nav>
        </form>
      </div>
    </div>
  </div>
</template>

<script>
import transitionService from '@/services/transitionService'

export default {
  name: 'MyInititatives',
  $_veeValidate: {
    validator: 'new'
  },
  components: {
    'su-service': () => import('@/components/SUService.vue')
  },
  computed: {
    isDisabled: function () {
      let toReturn = true
      if (this.hasBeenSavedOnce || this.initiative.id !== null) {
        toReturn = !this.hasChanged
      } else {
        toReturn = (this.initiatives_selected.length === 0 || this.initiative.description === '')
      }
      return toReturn
    }
  },
  data: function () {
    return {
      hasLaboratoire: false,
      erreur: '',
      hasChanged: false,
      savedInitiative: {},
      hasBeenSavedOnce: false,
      initiative: {
        id: null,
        created: null,
        last_update: null,
        description: '',
        initiative_institutionnelle: false,
        BGESext: 0,
        BGES_annee: [],
        groupe_description: '',
        deplacementspro_description: '',
        deplacementsdt_description: '',
        actrecherche_description: '',
        batiments_description: '',
        engagements: '',
        numerique_description: '',
        ecoresponsable: '',
        sociale: '',
        enquetes: '',
        communication: '',
        autres_initiatives: '',
        valid: false
      },
      initiatives_selected: [],
      initiatives_categories: [
        { 'valeur': 'Engagements' },
        { 'valeur': 'Activités de recherche' },
        { 'valeur': 'Groupe de réflexion' },
        { 'valeur': 'Déplacements professionnels' },
        { 'valeur': 'Déplacements domicile-travail' },
        { 'valeur': 'Bâtiments' },
        { 'valeur': 'Numérique' },
        { 'valeur': 'Actions éco-responsables' },
        { 'valeur': 'Initiatives à portée sociale' },
        { 'valeur': 'Enquêtes' },
        { 'valeur': 'Communication' },
        { 'valeur': 'Autres' }
      ],
      BGESAnneeValues: [
        { 'valeur': '2010' },
        { 'valeur': '2011' },
        { 'valeur': '2012' },
        { 'valeur': '2013' },
        { 'valeur': '2014' },
        { 'valeur': '2015' },
        { 'valeur': '2016' },
        { 'valeur': '2017' },
        { 'valeur': '2018' },
        { 'valeur': '2019' },
        { 'valeur': '2020' },
        { 'valeur': 'Retour' }
      ]
    }
  },
  methods: {
    validateBeforeSubmit () {
      this.$validator.validateAll().then((result) => {
        if (result) {
          const loadingComponent = this.$buefy.loading.open({
            container: null
          })
          transitionService.saveInitiative({
            'id': this.initiative.id,
            'created': this.initiative.created,
            'last_update': this.initiative.last_update,
            'description': this.initiative.description,
            'initiative_institutionnelle': this.initiative.initiative_institutionnelle,
            'BGESext': this.initiative.BGESext,
            'BGES_annee': this.initiative.BGES_annee.map(a => a.valeur).join(', '),
            'groupe_description': this.initiative.groupe_description,
            'deplacementspro_description': this.initiative.deplacementspro_description,
            'deplacementsdt_description': this.initiative.deplacementsdt_description,
            'actrecherche_description': this.initiative.actrecherche_description,
            'batiments_description': this.initiative.batiments_description,
            'engagements': this.initiative.engagements,
            'numerique_description': this.initiative.numerique_description,
            'ecoresponsable': this.initiative.ecoresponsable,
            'sociale': this.initiative.sociale,
            'enquetes': this.initiative.enquetes,
            'communication': this.initiative.communication,
            'autres_initiatives': this.initiative.autres_initiatives,
            'valid': this.initiative.valid
          })
            .then(data => {
              loadingComponent.close()
              this.initiative = data
              this.initiative.BGES_annee = this.initiative.BGES_annee.split(',').map(function (x) { return { 'valeur': x } })
              this.savedInitiative = JSON.parse(JSON.stringify(this.initiative))
              this.hasChanged = false
              this.erreur = ''
              this.hasBeenSavedOnce = true
              window.scrollTo(0, 0)
              this.$buefy.toast.open({
                type: 'is-light',
                message: 'Les initiatives de votre laboratoire ont été sauvegardées avec <strong><span style="color:green";>succès</span></strong>.'
              })
            })
            .catch((erreur) => {
              loadingComponent.close()
              this.erreur = erreur.response.data
              this.initiative = this.savedInitiative
            })
        }
      })
    },
    resetForm () {
      this.initiative = this.savedInitiative
      this.hasChanged = false
      this.erreur = ''
    },
    inputChanged () {
      this.hasChanged = true
    },
    changeBGESAnnee () {
      if (this.initiative.BGES_annee.filter(obj => obj.valeur === 'Retour').length === 1) {
        this.initiative.BGESext = '0'
        this.initiative.BGES_annee = []
      }
    },
    removeInitiative (ielement) {
      if (ielement.valeur === 'Groupe de réflexion') {
        this.initiative.groupe_description = ''
      } else if (ielement.valeur === 'Déplacements professionnels') {
        this.initiative.deplacementspro_description = ''
      } else if (ielement.valeur === 'Déplacements domicile-travail') {
        this.initiative.deplacementsdt_description = ''
      } else if (ielement.valeur === 'Activités de recherche') {
        this.initiative.actrecherche_description = ''
      } else if (ielement.valeur === 'Bâtiments') {
        this.initiative.batiments_description = ''
      } else if (ielement.valeur === 'Engagements') {
        this.initiative.engagements = ''
      } else if (ielement.valeur === 'Numérique') {
        this.initiative.numerique_description = ''
      } else if (ielement.valeur === 'Actions éco-responsables') {
        this.initiative.ecoresponsable = ''
      } else if (ielement.valeur === 'Initiatives à portée sociale') {
        this.initiative.sociale = ''
      } else if (ielement.valeur === 'Enquêtes') {
        this.initiative.enquetes = ''
      } else if (ielement.valeur === 'Communication') {
        this.initiative.communication = ''
      } else if (ielement.valeur === 'Autres') {
        this.initiative.autres_initiatives = ''
      }
    },
    isInitiativeSelected (initDesc) {
      return (this.initiatives_selected.filter(obj => obj.valeur === initDesc).length === 1)
    },
    scrollOnTop () {
      window.scrollTo(0, 0)
    },
    setInitative () {
      if (this.initiative.engagements) {
        this.initiatives_selected.unshift(this.initiatives_categories[0])
      }
      if (this.initiative.actrecherche_description) {
        this.initiatives_selected.unshift(this.initiatives_categories[1])
      }
      if (this.initiative.groupe_description) {
        this.initiatives_selected.unshift(this.initiatives_categories[2])
      }
      if (this.initiative.deplacementspro_description) {
        this.initiatives_selected.unshift(this.initiatives_categories[3])
      }
      if (this.initiative.deplacementsdt_description) {
        this.initiatives_selected.unshift(this.initiatives_categories[4])
      }
      if (this.initiative.batiments_description) {
        this.initiatives_selected.unshift(this.initiatives_categories[5])
      }
      if (this.initiative.numerique_description) {
        this.initiatives_selected.unshift(this.initiatives_categories[6])
      }
      if (this.initiative.ecoresponsable) {
        this.initiatives_selected.unshift(this.initiatives_categories[7])
      }
      if (this.initiative.sociale) {
        this.initiatives_selected.unshift(this.initiatives_categories[8])
      }
      if (this.initiative.enquetes) {
        this.initiatives_selected.unshift(this.initiatives_categories[9])
      }
      if (this.initiative.communication) {
        this.initiatives_selected.unshift(this.initiatives_categories[10])
      }
      if (this.initiative.autres_initiatives) {
        this.initiatives_selected.unshift(this.initiatives_categories[11])
      }
    }
  },
  mounted () {
    const loadingComponent = this.$buefy.loading.open({
      container: null
    })
    this.$store.dispatch('api/getLaboratory')
      .then(lab => {
        if (lab) {
          this.hasLaboratoire = (lab.id !== null)
        }
        transitionService.getInitiative()
          .then(initiative => {
            loadingComponent.close()
            if (Object.keys(initiative).length !== 0) {
              this.initiative = initiative
              this.initiative.BGES_annee = this.initiative.BGES_annee.split(',').map(function (x) { return { 'valeur': x } })
              this.savedInitiative = JSON.parse(JSON.stringify(this.initiative))
              this.setInitative()
            }
          })
          .catch((erreur) => {
            loadingComponent.close()
          })
      })
      .catch((erreur) => {
        loadingComponent.close()
        this.hasLaboratoire = false
      })
    this.hasChanged = false
  }
}
</script>
